/***
*
*          Copyright  1989  Lattice, Inc.
*
* name             _CXFPE -- low-level floating point error handler 
*
* synopsis         _CXFPE(sig);
*                  int sig;          signal number
*
* description      This function is the default function to be called
*                  when the SIGFPE signal has been raised.  It sets
*                  errno appropriately.
*
***/

#include <signal.h>
#include <math.h>
#include <errno.h>


extern void _CXFPE(int);

extern int _FPERR;



void _CXFPE(sig)
    int sig;
{
    switch(_FPERR) {
        case FPEUND:
        case FPEOVF:
        case FPEZDV:
            errno = ERANGE;
            break;
        case FPENAN:
        case FPECOM:
            errno = EDOM;
            break;
    }

    return;
}
